/*
 * Copyright (c) 2004-2005 Northwestern University.
 *                         NuCAD Group.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 * gsrc_info.h - Get infomation from GSRC benchmark to be used in fplan.
 *
 * Authors: Jia Wang, jwa112@ece.northwestern.edu
 *
 */

#ifndef GSRC_INFO_H
#define GSRC_INFO_H

#include "gsrc.h"
#include "../fplan/nets.h"

namespace fplan
{

void gsrc_info(int n,
	const std::vector<gsrc::module_t> &modules,
	const std::vector<gsrc::signal_t> &signals,
	std::vector<misc::dbl_pair> &module_shapes,
	std::vector<misc::cstr_t> &module_names,
	std::vector<misc::dbl_pair> &pin_locations,
	module_nets_t &mnets,
	const std::vector<gsrc::detailed_signal_t> *detailed = 0,
	pin_nets_t *pnets = 0);

bool gsrc_aux(const std::string &aux_name, int n,
	const std::vector<gsrc::module_t> &modules,
	const std::vector<gsrc::signal_t> &signals);

} // namespace fplan

#endif // GSRC_INFO_H
